## Author: Kenneth Lausdahl
1;

global destecsPlotResolution = 100;


function plotdata (titleStr, header, data)
#number of curves in the file
curveCount = length(header);

l = header;

#plot the data
	    timeCol = 1;
	    for i=1:curveCount
	    	    if(strcmpi(header{1,i},"time")==1)
	    	    	    timeCol = i;
	    	    endif;
	    end;
	    tmpData = data;
	    tmpData(:,timeCol)=[];#Remove TimeCol
	    l(timeCol)=[];#Remove TimeCol
plot( data(:,timeCol), tmpData(:, 1:curveCount-1 ) );
title(titleStr);
xlabel( header{timeCol} );
legend(strvcat(l));

endfunction



function header = parseheader (filename) 
#open the file
[vfid, vmsg] = fopen (filename, "r");
if (isempty (vmsg) == false), error (vmsg); endif

#Get the first line in the file (the header)
vstr = fgetl (vfid);

if(vstr == -1) header = cellstr(["time";]);
else
vstr = strrep(vstr,"\"","");
#split the string and remove all the spaces
header = strtrim( strsplit(vstr,",",true) );
endif;
fclose(vfid);
endfunction



function plotrun (runx) 
figure(1);
if (length(runx.de.data) != 0 && length(runx.ct.data)!=0)
subplot(2,1,1);
endif;if (length(runx.ct.data) != 0) 
plotdata(strcat("20-sim-",runx.name), runx.ct.header, runx.ct.data);
endif;
if (length(runx.de.data) != 0 && length(runx.ct.data)!=0)
subplot(2,1,2);
endif;if (length(runx.de.data) != 0) 
plotdata(strcat("VDM-",runx.name), runx.de.header, runx.de.data);
endif;endfunction



function res = reduceCsv (data)
	global destecsPlotResolution;
	res= data(1:ceil (rows(data)/destecsPlotResolution):end,:) ;
endfunction





function result = readResult ()

if exist("null","file") == 0
	de_header0 = [];
	de_data0 = [];
else
de_header0 = "";
de_data0 = "";
endif;
if exist("20simVariables.csv","file") == 0
	ct_header0 = [];
	ct_data0 = [];
else
ct_header0 = parseheader("20simVariables.csv");
ct_data0 = csvread("20simVariables.csv");
endif;

result = struct("name", "2014-10-24-04-38-33-LineFollowingRobot",
"de",struct("header",{de_header0},"data",{reduceCsv(de_data0)}),
"ct",struct("header",{ct_header0},"data",{reduceCsv(ct_data0)})
);


#Clean up
clear de_data0;
clear ct_data0;
endfunction


## Load last result automatically
lastrun = readResult();


